// Datum.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
#include "stdafx.h"
#include <iostream>
#include "hg_datum.h"

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "DatumMain" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;

  HG::Datum datum1; // Standardconstructor
  HG::Datum datum2;
  HG::Datum datum3 (31, 12, 2006);
  HG::Datum datum4 (datum3);
  HG::Datum datum5 (&datum3);
  HG::Datum datum6 = datum3;

  datum2.set (28, 2, 2000);

  cout << "datum1 (Standard-Constructor)      = " << datum1 << endl;
  cout << "datum2 (Standard-Constructor)      = " << datum2 << endl;
  cout << "datum3 (Constructor mit Werten)    = " << datum3 << endl;
  cout << "datum4 (Copy-Constructor Value)    = " << datum4 << endl;
  cout << "datum5 (Copy-Constructor Referenz) = " << datum5 << endl;
  cout << "datum6 (Zuweisung)                 = " << datum6 << endl;

  cout << endl;
  datum1.set (12, 2, 2007);

  cout << "datum1       = " << datum1 << endl;
  cout << "als Zahl     = " << datum1.getLong() << endl;
  cout << "Sortierbar   = " << datum1.getLongSortierbar() << endl;
  cout << "Streamoutput = " << datum1 << endl << endl;

  datum1.set (30, 2, 2000);
  cout << "datum1 = " << datum1 << endl;

  datum1.set (30, 2, 2001);
  cout << "datum1 = " << datum1 << endl;

  datum1.set (30, 2, 2100);
  cout << "datum1 = " << datum1 << endl;

  datum1.set (33, 23, 21000);
  cout << "datum1 = " << datum1 << endl;

  datum1.set (0, 0, 0);
  cout << "datum1 = " << datum1 << endl << endl;

  datum2.setTag(31);
  datum2.setMonat(1);
  datum2.setJahr(1999);
  cout << "datum2 = " << datum2 << endl;
  datum2.setHeute();
  cout << "datum2 = " << datum2 << endl << endl;

  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "Operatoren" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  datum2.setHeute();
  datum2 = datum2 + 7;
  cout << "Heute + 7 = " << datum2 << endl;

  datum2.setHeute();
  datum2 = 7 + datum2;
  cout << "7 + Heute = " << datum2 << endl;

  datum2.setHeute();
  datum2 = datum2 - 7;
  cout << "Heute - 7 = " << datum2 << endl;

  datum2.setHeute();
  datum2 = 7 - datum2;
  cout << "7 - Heute = " << datum2 << endl << endl;

  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "Inkrement & Dekrement" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  datum2.setHeute();
  datum3 = datum2++;
  cout << "Postinkrement zugewiesen = " << datum3 << endl;
  cout << "Postinkrement Ergebnis   = " << datum2 << endl << endl;
  
  datum2.setHeute();
  datum3 = ++datum2;
  cout << "Praeinkrement zugewiesen = " << datum3 << endl;
  cout << "Praeinkrement Ergebnis   = " << datum2 << endl << endl;

  datum2.setHeute();
  datum3 = datum2--;
  cout << "Postdekrement zugewiesen = " << datum3 << endl;
  cout << "Postdekrement Ergebnis   = " << datum2 << endl << endl;
  
  datum2.setHeute();
  datum3 = --datum2;
  cout << "Praedekrement zugewiesen = " << datum3 << endl;
  cout << "Praedekrement Ergebnis   = " << datum2 << endl << endl;

  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "Vergleiche" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  datum2.setHeute();
  datum4 = datum3 = datum2;
  cout << "Zuweisung auf datum3 = " << datum3 << endl;
  cout << "Zuweisung auf datum4 = " << datum4 << endl;
  cout << "datum2 == datum3: " << (datum2 == datum3 ? "true" : "false") << endl;
  cout << "datum2 >= datum3: " << (datum2 >= datum3 ? "true" : "false") << endl;
  cout << "datum2 <= datum3: " << (datum2 <= datum3 ? "true" : "false") << endl << endl;

  datum2 = datum2 - 2;
  cout << "datum2 = " << datum2 << endl;
  cout << "datum3 = " << datum3 << endl;
  cout << "datum2 == datum3: " << (datum2 == datum3 ? "true" : "false") << endl;
  cout << "datum2 != datum3: " << (datum2 != datum3 ? "true" : "false") << endl;
  cout << "datum2 >  datum3: " << (datum2 >  datum3 ? "true" : "false") << endl;
  cout << "datum2 <  datum3: " << (datum2 <  datum3 ? "true" : "false") << endl;
  cout << "datum2 >= datum3: " << (datum2 >= datum3 ? "true" : "false") << endl;
  cout << "datum2 <= datum3: " << (datum2 <= datum3 ? "true" : "false") << endl << endl;

  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "Mathematik" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  datum2.set(1, 1, 2000);
  cout << "datum2             = " << datum2 << endl;
  datum2.addJahre(15);
  cout << "datum2 + 15 Jahre  = " << datum2 << endl;
  datum2.subJahre(15);
  cout << "datum2 - 15 Jahre  = " << datum2 << endl;
  datum2.addMonate(15);
  cout << "datum2 + 15 Monate = " << datum2 << endl;
  datum2.subMonate(15);
  cout << "datum2 - 15 Monate = " << datum2 << endl;

  datum2.addTage(63);
  cout << "datum2 + 63 Tage   = " << datum2 << endl;
  datum2.subTage(64);
  cout << "datum2 - 64 Tage   = " << datum2 << endl << endl;
  datum2.set(1, 1, 2001);
  cout << "datum2             = " << datum2 << endl;
  datum2.addTage(63);
  cout << "datum2 + 63 Tage   = " << datum2 << endl;
  datum2.subTage(64);
  cout << "datum2 - 64 Tage   = " << datum2 << endl << endl;
  datum2.subTage(1000);
  cout << "datum2 - 1000 Tage = " << datum2 << endl << endl;

  cout << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  cout << "Ende: beliebige Eingabe + Enter" << endl;
  cout << "-------------------------------------------------------------------------------" << endl;
  char cWarteAufEnde;
  cin  >> cWarteAufEnde;
  return 0;
}

