#ifndef _HG_JAHRESTAG_H_
#define _HG_JAHRESTAG_H_

#include <string>
#include <iostream>
#include "hg_datum.h"

namespace HG //Beginn des Namensraumes
{

//==============================================================
// Klasse Datum
//==============================================================
class Jahrestag : public HG::Datum
{
  //------------------------------------------------------------
  // Constructoren
  //------------------------------------------------------------
  public:
    Jahrestag (void);                    // Standardconstructor
    Jahrestag (std::string pText);    
    Jahrestag (Jahrestag &pJahrestag);   // Copy-Constructor
    Jahrestag (Jahrestag *ptrJahrestag); // "Copy"-Constructor (nicht automatisch)
    Jahrestag (Datum &pDatum);           // Basis-Copy-Constructor
    Jahrestag (Datum *ptrDatum);         // Basis-"Copy"-Constructor (nicht automatisch)
    Jahrestag (int pTag, int pMonat, int pJahr);
	Jahrestag (int pTag, int pMonat, int pJahr, std::string pText);

  //------------------------------------------------------------
  // Methoden 
  //------------------------------------------------------------
  public:

  //------------------------------------------------------------
  // Methoden: berladene Operatoren
  //------------------------------------------------------------
   bool  operator== (Jahrestag &pToCompare);
   bool  operator!= (Jahrestag &pToCompare);
   bool  operator>  (Jahrestag &pToCompare);
   bool  operator>= (Jahrestag &pToCompare);
   bool  operator<  (Jahrestag &pToCompare);
   bool  operator<= (Jahrestag &pToCompare);

   Jahrestag operator++ (void);  // Operator: Princrement
   Jahrestag operator++ (int);   // Operator: Postincrement
   Jahrestag operator-- (void);  // Operator: Prdecrement
   Jahrestag operator-- (int);   // Operator: Postdecrement
   Jahrestag operator=  (Jahrestag &pToCopy);
   Jahrestag operator=  (Datum &pToCopy);
   Jahrestag operator=  (std::string &pText);
   Jahrestag operator=  (char *pText);
   Jahrestag operator+  (int pToAdd);
   Jahrestag operator-  (int pToSubtract);

  //------------------------------------------------------------
  // Methoden: Getter und Setter 
  //------------------------------------------------------------
  public:
	std::string  getText   (void);
	void         setText   (std::string pText);

  //------------------------------------------------------------
  // Methoden, intern
  //------------------------------------------------------------
  private:
	void init    (void);

  //------------------------------------------------------------
  // Member
  //------------------------------------------------------------
  private:
	std::string sText;
};

} // Ende des Namensraumes

HG::Jahrestag operator+  (int pToAdd,            HG::Jahrestag &pTarget);
HG::Jahrestag operator-  (int pToSubtract,       HG::Jahrestag &pTarget);
std::ostream& operator<< (std::ostream &pStream, HG::Jahrestag &pToShow);
#endif