#ifndef _HG_UHRZEIT_H_
#define _HG_UHRZEIT_H_

#include <string>
#include <iostream>

namespace HG //Beginn des Namensraumes
{

//==============================================================
// Klasse Uhrzeit
//==============================================================
class Uhrzeit
{
  //------------------------------------------------------------
  // Constructoren
  //------------------------------------------------------------
  public:
     Uhrzeit  (void);                // Standardconstructor
     Uhrzeit  (Uhrzeit &pUhrzeit);   // Copy-Constructor
     Uhrzeit  (Uhrzeit *ptrUhrzeit); // "Copy"-Constructor (nicht automatisch)
     Uhrzeit  (int pStunde, int pMinute);
	 ~Uhrzeit ();

  //------------------------------------------------------------
  // Methoden 
  //------------------------------------------------------------
  public:
    void        set               (int pStunde, int pMinute);
    long        getLong           (void);
    void        setJetzt          (void);
    int         addMinute         (int pToAdd);
    int         subMinute         (int pToSub);
    int         addStunde         (int pToAdd);
    int         subStunde         (int pToSub);

  //------------------------------------------------------------
  // Methoden: berladene Operatoren
  //------------------------------------------------------------
   Uhrzeit operator++ (void);  // Operator: Princrement
   Uhrzeit operator++ (int);   // Operator: Postincrement
   Uhrzeit operator-- (void);  // Operator: Prdecrement
   Uhrzeit operator-- (int);   // Operator: Postdecrement
   Uhrzeit operator+  (int pToAdd);
   Uhrzeit operator-  (int pToSubtract);
   Uhrzeit operator=  (Uhrzeit &pToCopy);
   bool  operator==   (Uhrzeit &pToCompare);
   bool  operator!=   (Uhrzeit &pToCompare);
   bool  operator>    (Uhrzeit &pToCompare);
   bool  operator>=   (Uhrzeit &pToCompare);
   bool  operator<    (Uhrzeit &pToCompare);
   bool  operator<=   (Uhrzeit &pToCompare);

  //------------------------------------------------------------
  // Methoden: Getter und Setter 
  //------------------------------------------------------------
  public:
    int  getStunde (void);
    void setStunde (int pStunde);
    int  getMinute (void);
    void setMinute (int pMinute);

	static char getSeperator(void);
	static char setSeperator(char c);

  //------------------------------------------------------------
  // Methoden, intern
  //------------------------------------------------------------
  private:
    void correct (void);

  //------------------------------------------------------------
  // Member
  //------------------------------------------------------------
  private:
    int nStunde;
    int nMinute;

	char static cSeperator;
};

} // Ende des Namensraumes

HG::Uhrzeit operator+ (int pToAdd, HG::Uhrzeit &pTarget); // Version 2
HG::Uhrzeit operator- (int pToSubtract, HG::Uhrzeit &pTarget); // Version 2
std::ostream& operator<< (std::ostream &pStream, HG::Uhrzeit &pToShow);
#endif